import java.util.*;

public class Scheme 
{ 
    public static Scheme instance;

    Line[] metroLines; 
    Cross[] metroCrosses;

    public Scheme(String schemeDefinition) { 
        metroLines = new Line[]{
            new Line("U1", 0x4C7446, new Station[]{
                         new Station("Georg Brauchle Ring[1]", 1, 112, 200),
                         new Station("Westfriedhof[1]", 2, 112, 217),
                         new Station("Gern[1]", 1, 112, 236),
                         new Station("Rotkreuzplatz[1]", 2, 112, 257),
                         new Station("Mailingerstrasse[1]", 1, 158, 267),
                         new Station("Stiglmaierplatz[1]", 6, 198, 267),
                         new Station("Hauptbahnhof[1]", 4, 220, 337),
                         new Station("Sendlinger Tor[1]", 1, 317, 368),
                         new Station("Frauenhoferstrasse[1]", 2, 350, 368),
                         new Station("Kolumbusplatz[1]", 1, 379, 368),
                         new Station("Candidplatz[1]", 1, 393, 410),
                         new Station("Wettersteinplatz[1]", 1, 393, 432),
                         new Station("St.-Quirin-Platz[1]", 2, 382, 452),
                         new Station("Mangfallplatz[1]", 0, 369, 466),
                     }), 
            new Line("U2", 0xB21D36, new Station[]{
                         new Station("Feldmoching[2]", 1, 66, 128),
                         new Station("Hasenbergl[2]", 1, 109, 128),
                         new Station("Dlferstrasse[2]", 2, 141, 128),
                         new Station("Harthof[2]", 1, 175, 128),
                         new Station("Am Hart[2]", 2, 212, 128),
                         new Station("Frankfurter Ring[2]", 1, 223, 138),
                         new Station("Milbertshofen[2]", 2, 223, 159),
                         new Station("Scheidplatz[2]", 2, 223, 182),
                         new Station("Hohenzollernplatz[2]", 1, 223, 203),
                         new Station("Josephsplatz[2]", 1, 223, 222),
                         new Station("Theresienstrasse[2]", 1, 223, 241),
                         new Station("Knigsplatz[2]", 2, 223, 260),
                         new Station("Hauptbahnhof[2]", 2, 220, 337),
                         new Station("Sendlinger Tor[2]", 1, 317, 368),
                         new Station("Frauenhoferstrasse[2]", 2, 350, 368),
                         new Station("Kolumbusplatz[2]", 1, 379, 368),
                         new Station("Silberhornstrasse[2]", 1, 408, 366),
                         new Station("Untersbergstrasse[2]", 1, 431, 366),
                         new Station("Giesing Bahnhof[2]", 2, 461, 366),
                         new Station("Karl-Preis-Platz[2]", 2, 506, 366),
                         new Station("Innsbrucker Ring[2]", 2, 551, 366),
                         new Station("Josephsburg[2]", 1, 594, 336),
                         new Station("Kreillerstrasse[2]", 2, 594, 302),
                         new Station("Trudering[2]", 1, 594, 276),
                         new Station("Moosfeld[2]", 2, 594, 249),
                         new Station("Messestadt West[2]", 1, 594, 225),
                         new Station("Messestadt Ost[2]", 0, 594, 201),
                     }), 
            new Line("U3", 0xE86F12, new Station[]{
                         new Station("Olympiazentrum[3]", 1, 171, 182),
                         new Station("Petuelring[3]", 2, 197, 182),
                         new Station("Scheidplatz[3]", 1, 223, 182),
                         new Station("Bonner Platz[3]", 2, 269, 182),
                         new Station("Mnchner Freiheit[3]", 1, 317, 196),
                         new Station("Giselastrasse[3]", 2, 317, 218),
                         new Station("Universitt[3]", 1, 317, 240),
                         new Station("Odeonsplatz[3]", 2, 317, 264),
                         new Station("Marienplatz[3]", 1, 317, 315),
                         new Station("Sendlinger Tor[3]", 2, 317, 368),
                         new Station("Goetheplatz[3]", 1, 301, 404),
                         new Station("Poccistrasse[3]", 1, 266, 419),
                         new Station("Implerstrasse[3]", 2, 234, 419),
                         new Station("Brudermhlstrasse[3]", 2, 218, 445),
                         new Station("Thalkirchen[3]", 1, 184, 459),
                         new Station("Obersendling[3]", 2, 131, 459),
                         new Station("Aidenbachstrasse[3]", 1, 89, 459),
                         new Station("Machtlfinger Strasse[3]", 2, 54, 467),
                         new Station("Forstenrieder Allee[3]", 1, 46, 492),
                         new Station("Basler Strasse[3]", 1, 46, 516),
                         new Station("Frstenried West[3]", 0, 46, 539),
                     }), 
            new Line("U4", 0x01AAB1, new Station[]{
                         new Station("Westendstrasse[4]", 1, 88, 374),
                         new Station("Heimeranplatz[4]", 1, 122, 374),
                         new Station("Schwanthalerhhe[4]", 2, 153, 374),
                         new Station("Theresienwiese[4]", 1, 189, 356),
                         new Station("Hauptbahnhof[4]", 1, 220, 337),
                         new Station("Karlsplatz[4]", 2, 268, 315),
                         new Station("Odeonsplatz[4]", 1, 317, 264),
                         new Station("Lehel[4]", 2, 367, 264),
                         new Station("Max-Weber-Platz[4]", 1, 415, 264),
                         new Station("Prinzregentenplatz[4]", 1, 428, 242),
                         new Station("Bhmerwaldplatz[4]", 1, 428, 222),
                         new Station("Richard-Strauss-Strasse[4]", 2, 428, 200),
                         new Station("Arabellapark[4]", 0, 448, 183),
                     }),
            new Line("U5", 0xDBAD4C, new Station[]{
                         new Station("Laimer Platz[5]", 1, 29, 377),
                         new Station("Friedenheimer Strasse[5]", 2, 58, 377),
                         new Station("Westendstrasse[5]", 1, 88, 374),
                         new Station("Heimeranplatz[5]", 2, 122, 374),
                         new Station("Schwanthalerhhe[5]", 2, 153, 374),
                         new Station("Theresienwiese[5]", 4, 189, 356),
                         new Station("Hauptbahnhof[5]", 1, 220, 337),
                         new Station("Karlsplatz[5]", 5, 268, 315),
                         new Station("Odeonsplatz[5]", 1, 317, 264),
                         new Station("Lehel[5]", 2, 367, 264),
                         new Station("Max-Weber-Platz[5]", 1, 415, 264),
                         new Station("Ostbahnhof[5]", 3, 468, 313),
                         new Station("Innsbrucker Ring[5]", 1, 551, 266),
                         new Station("Michaelibad[5]", 2, 551, 288),
                         new Station("Quiddenstrasse[5]", 1, 551, 403),
                         new Station("Neuperlach Zentrum[5]", 2, 551, 418),
                         new Station("Therese-Giehse-Allee[5]", 1, 551, 435),
                         new Station("Neuperlach Sd[5]", 0, 551, 453),
                     }), 
            new Line("U6", 0x13508E, new Station[]{
                         new Station("Garching-Hochbrck[6]", 4, 320, 62),
                         new Station("Frttmaning[6]", 3, 320, 83),
                         new Station("Kieferngarten[6]", 2, 320, 200),
                         new Station("Freimann[6]", 2, 320, 117),
                         new Station("Studentenstadt[6]", 1, 320, 133),
                         new Station("Alte Heide[6]", 1, 320, 148),
                         new Station("Nordfriedhof[6]", 1, 320, 163),
                         new Station("Dietlindenstrasse[6]", 2, 320, 177),
                         new Station("Mnchner Freiheit[6]", 2, 317, 196),
                         new Station("Giselastrasse[6]", 2, 317, 218),
                         new Station("Universitt[6]", 1, 317, 140),
                         new Station("Odeonsplatz[6]", 2, 317, 264),
                         new Station("Marienplatz[6]", 1, 317, 315),
                         new Station("Sendlinger Tor[6]", 2, 317, 368),
                         new Station("Goetheplatz[6]", 1, 301, 404),
                         new Station("Poccistrasse[6]", 1, 266, 419),
                         new Station("Implerstrasse[6]", 2, 234, 419),
                         new Station("Harras[6]", 2, 120, 422),
                         new Station("Partnachplatz[6]", 1, 93, 422),
                         new Station("Westpark[6]", 2, 65, 422),
                         new Station("Holzapfelkreuth[6]", 1, 30, 430),
                         new Station("Haderner Stern[6]", 2, 14, 447),
                         new Station("Grosshadern[6]", 1, 5, 471),
                         new Station("Klinikum Grosshadern[6]", 0, 5, 497),
                     }), 
        };


        metroCrosses = new Cross[] {
            new Cross("Hauptbahnhof[1]", "Hauptbahnhof[2]", 4),
            new Cross("Hauptbahnhof[1]", "Hauptbahnhof[4]", 5),
            new Cross("Hauptbahnhof[1]", "Hauptbahnhof[5]", 5),
            new Cross("Hauptbahnhof[2]", "Hauptbahnhof[4]", 5),
            new Cross("Hauptbahnhof[2]", "Hauptbahnhof[5]", 5),
            new Cross("Kolumbusplatz[1]", "Kolumbusplatz[2]", 5),
            new Cross("Sendlinger Tor[1]", "Sendlinger Tor[3]", 5),
            new Cross("Sendlinger Tor[1]", "Sendlinger Tor[6]", 5),
            new Cross("Scheidplatz[2]", "Scheidplatz[3]", 2),
            new Cross("Innsbrucker Ring[2]", "Innsbrucker Ring[5]", 5),
            new Cross("Mnchner Freiheit[3]", "Mnchner Freiheit[6]", 5),
            new Cross("Odeonsplatz[3]", "Odeonsplatz[4]", 5),
            new Cross("Odeonsplatz[3]", "Odeonsplatz[5]", 5),
            new Cross("Odeonsplatz[6]", "Odeonsplatz[4]", 5),
            new Cross("Odeonsplatz[6]", "Odeonsplatz[5]", 5),
            new Cross("Implerstrasse[3]", "Implerstrasse[6]", 5),
            new Cross("Westendstrasse[4]", "Westendstrasse[5]", 5),
            new Cross("Max-Weber-Platz[4]", "Max-Weber-Platz[5]", 5),
        };
        instance = this;
    }

    /*
    public Scheme(String schemeDefinition) { 
        XMLParser parser = new XMLParser(schemeDefinition);
        Enumeration e = parser.enumerateRootSiblings("scheme");
        Vector lines = new Vector();
        Vector crosses = new Vector();
        while (e.hasMoreElements()) { 
            XMLElement elem = (XMLElement)e.nextElement();
            String name = elem.getName();
            if (name.equals("line")) { 
                XMLElement station = elem.getSibling("station");
                int n = station.getCounter();
                Station[] stations = new Station[n];
                for (int i = 0; i < n; i++) { 
                    stations[i] = new Station(station.getStringAttribute("name"),
                                              station.getIntAttribute("time"),
                                              station.getIntAttribute("x"),
                                              station.getIntAttribute("y"));
                }
                Line line = new Line(elem.getStringAttribute("name"), stations);
                lines.addElement(line);
            } else if (name.equals("cross")) {
                crosses.addElement(new Cross(elem.getStringAttribute("from"),
                                             elem.getStringAttribute("to"),
                                             elem.getIntAttribute("time")));
            }
        }
        metroLines = new Line[lines.size()];
        for (int i = 0; i < metroLines.length; i++) { 
            metroLines[i] = (Line)lines.elementAt(i);
        }
        metroCrosses = new Cross[crosses.size()];
        for (int i = 0; i < metroCrosses.length; i++) { 
            metroCrosses[i] = (Cross)crosses.elementAt(i);
        }
        instance = this;
    }
    */
}
